Attribute VB_Name = "modMHDock"
Option Explicit

Public Type seVarsType
    origWndProc As Long ' Parent form's original WndProc address
    lParenthWnd As Long ' Parent form's hWnd
    lTophWnd As Long    ' MDIForm parent form hWnd
    lTrayhWnd As Long   ' System tray hWnd
    lseHwnd As Long     ' MHDock control hWnd
    lxDock As Long      ' xDock property
    lyDock As Long      ' yDock property
    bDockEnabled As Long
End Type

Public Type RECT
    Left As Long
    Top As Long
    Right As Long
    Bottom As Long
End Type

Public Type POINTAPI
    X As Long
    Y As Long
End Type

Public Declare Function CallWindowProc Lib "user32" Alias "CallWindowProcA" (ByVal lpPrevWndFunc As Long, ByVal hwnd As Long, ByVal Msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Public Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (hpvDest As Any, hpvSource As Any, ByVal cbCopy As Long)
Public Declare Function FindWindow Lib "user32" Alias "FindWindowA" (ByVal lpClassName As String, ByVal lpWindowName As String) As Long
Public Declare Function GetCursorPos Lib "user32" (lpPoint As POINTAPI) As Long
Public Declare Function GetDesktopWindow Lib "user32" () As Long
Public Declare Function GetParent Lib "user32" (ByVal hwnd As Long) As Long
Public Declare Function GetWindowLong Lib "user32" Alias "GetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long) As Long
Public Declare Function GetWindowRect Lib "user32" (ByVal hwnd As Long, lpRect As RECT) As Long
Public Declare Function GlobalAlloc Lib "kernel32" (ByVal wFlags As Long, ByVal dwBytes As Long) As Long
Public Declare Function GlobalFree Lib "kernel32" (ByVal hMem As Long) As Long
Public Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) As Long
Public Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long
Public Declare Function SystemParametersInfo Lib "user32" Alias "SystemParametersInfoA" (ByVal uAction As Long, ByVal uParam As Long, lpvParam As Any, ByVal fuWinIni As Long) As Long
    
Public Const GWL_WNDPROC = (-4)
Public Const WM_DESTROY = &H2
Public Const WM_MOVE = &H3
Public Const WM_MOVING = &H216
Public Const WM_MOUSEMOVE = &H200
Public Const WM_ENTERSIZEMOVE = &H231
Public Const WM_EXITSIZEMOVE = &H232
Public Const SPI_GETBORDER = 5

Public Const GMEM_FIXED = &H0
Public Const GMEM_ZEROINIT = &H40
Public Const GPTR = (GMEM_FIXED Or GMEM_ZEROINIT)

Dim seVars As seVarsType, hMem As Long, lLasthWnd As Long

Public Function AppWndProc(ByVal hwnd As Long, ByVal Msg As Long, _
    ByVal wParam As Long, ByVal lParam As Long) As Long
    Static pSave As POINTAPI, bSnappedX As Boolean, _
        bSnappedY As Boolean
    Static bLeft As Boolean, bTop As Boolean, bRight As Boolean, _
        bBottom As Boolean
    Static rOrig As RECT, bOrig As Boolean, rParent As RECT, _
        rLatest As RECT
    Static lMinX As Long, lMaxX As Long, lMinY As Long, _
        lMaxY As Long
    Static lxDock As Long, lyDock As Long
    
    If hwnd <> lLasthWnd Then
        ' Get the seVars structure copy from the locked memory
        hMem = Val(GetSetting("MHDock", "hMem", CStr(hwnd)))
        CopyMemory seVars, ByVal hMem, LenB(seVars)
        lLasthWnd = hwnd
    End If
    
    Dim bDockNow As Boolean, P As POINTAPI, rTemp As RECT
    Dim lBorder As Long, lEvent As Long
    Select Case Msg
        Case WM_ENTERSIZEMOVE, WM_EXITSIZEMOVE
            Dim pErase As POINTAPI
            Dim rErase As RECT
            pSave = pErase
            bSnappedX = False
            bSnappedY = False
            bLeft = False
            bTop = False
            bRight = False
            bBottom = False
            rOrig = rErase
            bOrig = False
            rParent = rErase
            rLatest = rErase
            lMinX = 0
            lMaxX = 0
            lMinY = 0
            lMaxY = 0
            lxDock = 0
            lyDock = 0
        Case WM_MOVING
            If seVars.bDockEnabled Then
                ' The user is moving the Form. The moving rectangle
                ' is passed as a pointer in lParam
                CopyMemory rLatest, ByVal lParam, Len(rLatest)
                If Not bOrig Then
                    ' First time in - get the parent rectangle to
                    ' determine docking position
                    bOrig = True: LSet rOrig = rLatest
                    GetWindowRect seVars.lTophWnd, rParent
                    lMinX = rParent.Left
                    lMaxX = rParent.Right
                    lMinY = rParent.Top
                    lMaxY = rParent.Bottom
                    lxDock = seVars.lxDock \ Screen.TwipsPerPixelX
                    lyDock = seVars.lyDock \ Screen.TwipsPerPixelY
                    If seVars.lTrayhWnd Then
                        ' This form is on the screen - get the tray
                        ' position and offset the Dock positions
                        GetWindowRect seVars.lTrayhWnd, rTemp
                        If rTemp.Left > 0 Then
                            ' Bar is on the right
                            lMaxX = lMaxX - (rTemp.Right - _
                                rTemp.Left) + 2
                        ElseIf rTemp.Top > 0 Then
                            ' Bar is on the bottom
                            lMaxY = lMaxY - (rTemp.Bottom - _
                                rTemp.Top) + 2
                        ElseIf rTemp.Right > lMaxX \ 2 Then
                            ' Bar is on the top
                            lMinY = rTemp.Bottom
                        Else
                            ' Bar is on the left
                            lMinX = rTemp.Right
                        End If
                    Else
                        ' This is a child window, so don't try to
                        ' dock beyond the parent's borders
                        SystemParametersInfo SPI_GETBORDER, 0, lBorder, 0
                        lBorder = lBorder * 2
                        lMinX = lMinX + lBorder
                        lMaxX = lMaxX - lBorder
                        lMinY = lMinY + lBorder
                        lMaxY = lMaxY - lBorder
                    End If
                End If
                If rLatest.Left <= lMinX + lxDock Then
                    ' Dock to the left
                    bDockNow = True
                    rLatest.Left = lMinX
                    rLatest.Right = rLatest.Left + (rOrig.Right - _
                        rOrig.Left)
                    bLeft = True
                ElseIf rLatest.Right >= lMaxX - lxDock Then
                    ' Dock to the right
                    bDockNow = True
                    rLatest.Right = lMaxX
                    rLatest.Left = rLatest.Right - (rOrig.Right - _
                        rOrig.Left)
                    bRight = True
                End If
                If rLatest.Top <= lMinY + lyDock Then
                    ' Dock to the top
                    bDockNow = True
                    rLatest.Top = lMinY
                    rLatest.Bottom = rLatest.Top + (rOrig.Bottom - _
                        rOrig.Top)
                    bTop = True
                ElseIf rLatest.Bottom >= lMaxY - lyDock Then
                    ' Dock to the bottom
                    bDockNow = True
                    rLatest.Bottom = lMaxY
                    rLatest.Top = rLatest.Bottom - (rOrig.Bottom - _
                        rOrig.Top)
                    bBottom = True
                End If
                If bDockNow Or bSnappedX Or bSnappedY Then
                    ' User needs to Dock or is currently Docked
                    ' (and we need to check for unDock conditions)
                    GetCursorPos P
                    If bDockNow And Not bSnappedX And (bLeft Or _
                        bRight) Then
                        ' First time Docking Left or Right
                        bSnappedX = True
                        LSet pSave = P
                    ElseIf bSnappedX Then
                        ' Docked on the Left or Right - check for
                        ' unDock conditions
                        If bLeft Then
                            If P.X > pSave.X + lxDock Then
                                rLatest.Left = lMinX + lxDock + 1
                                rLatest.Right = rLatest.Left + _
                                    (rOrig.Right - rOrig.Left)
                                bLeft = False
                                bSnappedX = False
                            ElseIf P.X < pSave.X Then
                                LSet pSave = P
                            End If
                        ElseIf bRight Then
                            If P.X < pSave.X - lxDock Then
                                rLatest.Right = lMaxX - lxDock - 1
                                rLatest.Left = rLatest.Right - _
                                    (rOrig.Right - rOrig.Left)
                                bRight = False
                                bSnappedX = False
                            ElseIf P.X > pSave.X Then
                                ' No need to unDock, so save the
                                ' cursor position
                                LSet pSave = P
                            End If
                        End If
                    End If
                    If bDockNow And Not bSnappedY And _
                        (bTop Or bBottom) Then
                        ' First time Docking Top or Bottom
                        bSnappedY = True
                        LSet pSave = P
                    ElseIf bSnappedY Then
                        ' Docked on the Top or Bottom - check for
                        ' unDock conditions
                        If bTop Then
                            If P.Y > pSave.Y + lyDock Then
                                rLatest.Top = lMinY + lyDock + 1
                                rLatest.Bottom = rLatest.Top + _
                                    (rOrig.Bottom - rOrig.Top)
                                bTop = False
                                bSnappedY = False
                            ElseIf P.Y < pSave.Y Then
                                LSet pSave = P
                            End If
                        ElseIf bBottom Then
                            If P.Y < pSave.Y - lyDock Then
                                rLatest.Bottom = lMaxY - lyDock - 1
                                rLatest.Top = rLatest.Bottom - _
                                    (rOrig.Bottom - rOrig.Top)
                                bBottom = False
                                bSnappedY = False
                            ElseIf P.Y > pSave.Y Then
                                LSet pSave = P
                            End If
                        End If
                    End If
                    ' Copy the modified RECT back into the
                    ' original pointed to by lParam
                    CopyMemory ByVal lParam, rLatest, Len(rLatest)
                End If
            End If
        Case WM_MOVE
            ' Fire the original handler right away
            AppWndProc = CallWindowProc(seVars.origWndProc, hwnd, _
                Msg, wParam, lParam)
            If seVars.bDockEnabled Then
                ' Form was dropped - reset all flags and cause a
                ' MouseMove event back in the UserControl so that
                ' the Moved event can fire.
                If bOrig Then
                    If bSnappedX Then
                        If bLeft Then
                            lEvent = 1
                        Else
                            lEvent = 2
                        End If
                    End If
                    If bSnappedY Then
                        If bTop Then
                            lEvent = lEvent Or &H10000
                        Else
                            lEvent = lEvent Or &H20000
                        End If
                    End If
                    SendMessage seVars.lseHwnd, WM_MOUSEMOVE, 0, _
                        ByVal lEvent
                End If
                bSnappedX = False
                bSnappedY = False
                bLeft = False
                bTop = False
                bRight = False
                bBottom = False
                bOrig = False
            Else
                SendMessage seVars.lseHwnd, WM_MOUSEMOVE, 0, ByVal 0
            End If
            Exit Function
        Case WM_DESTROY
            ' In case the Form is destroyed before the
            ' Terminate event of the Control
            AppWndProc = CallWindowProc(seVars.origWndProc, hwnd, _
                Msg, wParam, lParam)
            SetHook hwnd, False, seVars.origWndProc
            Exit Function
    End Select
    AppWndProc = CallWindowProc(seVars.origWndProc, hwnd, Msg, _
        wParam, lParam)
End Function

Public Sub SetHook(hwnd, bSet As Boolean, origWndProc As Long)
    If bSet Then
        origWndProc = SetWindowLong(hwnd, GWL_WNDPROC, AddressOf AppWndProc)
    ElseIf origWndProc Then
        If GetWindowLong(hwnd, GWL_WNDPROC) <> origWndProc Then
            SetWindowLong hwnd, GWL_WNDPROC, origWndProc
        End If
    End If
End Sub
